#!/bin/sh
SHK_VERSION=0131.00
CURR_SDK_VERSION=0131
#!/bin/sh
SHK_VERSION=0131.00
CURR_SDK_VERSION=0131


cd /
### Framework Variables
FRMWRK_INST_PATH="/Library/Frameworks/Sentinel.framework"
FRMWRK_PCKG_INST_PATH="/Library/Receipts/SentinelFramework.pkg"
SNTL_COMM_PATH="/Applications/Safenet Sentinel"
SRVR_INST_PATH="/Applications/Safenet Sentinel/Common Files/Sentinel Keys Server"
SKPI_INST_PATH="/Applications/Safenet Sentinel/Sentinel Keys/1.3/Sentinel Keys Protection Installer"
SNTL_COMM_PATH="/Applications/Safenet Sentinel/"
#DRIVER_COMM_PATH="/Applications/Safenet Sentinel/Common Files/Sentinel Mac Driver"
DRIVER_PCKG_INST_PATH="Library/Receipts/SentinelSystemDriver.pkg"

### Package Variables
PCKG_INST_PATH="/Library/Receipts/SentinelKeysProtectionInstaller.pkg"
SUPRO_PCKG_PATH=/Library/Receipts/SentinelSuperPro*
SUPRO_DRIVER_PATH=/Library/Receipts/SentinelDriver1.0.0*

UPRO_PCKG_PATH="/Library/Receipts/SentinelUltraPro(English).pkg"
UPRO_SPI_PATH="/Library/Receipts/SentinelProtectionInstaller.pkg"
UPRO_DRIVER_PATH="/Library/Receipts/SentinelDriver1.0.0.2.pkg"
UPRO_FRMWRK_PATH="/Library/Receipts/SentinelFramework.pkg"
UPRO_KM_PATH="/Library/Receipts/SentinelKeyManager(English).pkg"

ISDRIVER=0
ISSERVER=0
ISSDK_102=0

dash_ln="----------------------------------------------------------------------"

echo $dash_ln
echo "              Sentinel Keys Protection version 1.3.1 Un-installation Script"
echo "                   Copyright (C) 2009 SafeNet, Inc."
echo "                         All rights reserved."
echo $dash_ln
echo

### Check whether Sentinel Keys Protection Installer package is installed
#   [ -d "$PCKG_INST_PATH" ]
#   if [ $? -ne 0 ]
#   then
#      echo "Sentinel Keys Protection Installer package not installed.";echo
#      exit
#   fi

[ -f "/Library/Receipts/SafenetSentinelProduct.Info" ]
  if [ $? -eq 0 ]
   then
    sudo chmod 777 /Library/Receipts/SafenetSentinelProduct.Info
    sdk_version=`grep SentinelKeysProtection /Library/Receipts/SafenetSentinelProduct.Info | cut -d = -f 2 | cut -d : -f 1`
    if [ $sdk_version ]
    then
	  echo  
    else
       echo "Sentinel Keys SDK package not installed.";echo 
       exit
    fi
  else
     echo "Sentinel Keys SDK package is not installed.";echo 
      exit
   fi

### Sentinel Keys Protection Installer package found

### Check if the current user has administrative rights
   id | grep "admin" > /dev/null 2>&1
   if [ $? -ne 0 ]
   then 
       echo "To uninstall this package you should have root permission."
       echo "Uninstallation aborted."
       echo 
       exit
   fi
 
### Check if some other application is also using this package.

[ -f "/Library/Receipts/SafenetSentinelProduct.Info" ]
if [ $? -eq 0 ]
then
    sudo chmod 777 /Library/Receipts/SafenetSentinelProduct.Info
    skpi_version=`grep SentinelKeysProtection /Library/Receipts/SafenetSentinelProduct.Info | cut -d = -f 2 | cut -d : -f 1`
    if [ $skpi_version = $SHK_VERSION ]
    then
       current_inst=`grep SentinelKeysProtection /Library/Receipts/SafenetSentinelProduct.Info | cut -d = -f 3`
       if [ $current_inst -gt 1 ]
       then  
          echo "Unable to uninstall the Sentinel Keys Protection Installer due to other users/applications dependency!!"      
          decrement_inst=1
          count_SKPI=`expr $current_inst - $decrement_inst`
          sudo echo "/SentinelKeysProtection/" > /tmp/SNTLCMD
          sudo echo "d" >> /tmp/SNTLCMD; echo "w" >> /tmp/SNTLCMD; echo "q" >> /tmp/SNTLCMD
          (sudo grep "SentinelKeysProtection" /Library/Receipts/SafenetSentinelProduct.Info && sudo ed /Library/Receipts/SafenetSentinelProduct.Info < /tmp/SNTLCMD) > /dev/null 2>&1 
          echo "SentinelKeysProtection="$SHK_VERSION":Count="$count_SKPI  >>  /Library/Receipts/SafenetSentinelProduct.Info
          rm -rf /tmp/SNTLCMD
          exit
       fi 
      
       if [ $current_inst = 1 ]
       then  
          decrement_inst=1
          count_SKPI=`expr $current_inst - $decrement_inst`
          sudo echo "/SentinelKeysProtection/" > /tmp/SNTLCMD
          sudo echo "d" >> /tmp/SNTLCMD; echo "w" >> /tmp/SNTLCMD; echo "q" >> /tmp/SNTLCMD
          (sudo grep "SentinelKeysProtection" /Library/Receipts/SafenetSentinelProduct.Info && sudo ed /Library/Receipts/SafenetSentinelProduct.Info < /tmp/SNTLCMD) > /dev/null 2>&1
          #echo "SentinelKeysProtection="$SHK_VERSION":Count="$count_SKPI >>  /Library/Receipts/SafenetSentinelProduct.Info
          sed  "/^SentinelKeysProtection="$SHK_VERSION":Count="$count_SKPI"/d" /Library/Receipts/SafenetSentinelProduct.Info > /tmp/SNTLCMD
          sudo cp /tmp/SNTLCMD /Library/Receipts/SafenetSentinelProduct.Info  
          rm -rf /tmp/SNTLCMD
       fi
  else
    echo "Sentinel Keys Protection Installer 1.3.1 is not installed!!"
    exit
  fi
sudo chmod 775 /Library/Receipts/SafenetSentinelProduct.Info
fi
      
### Remove UninstallSentinelKeysProtection.sh
    sudo rm -rf "$SNTL_COMM_PATH"/Sentinel\ Keys/1.3/Sentinel\ Keys\ Protection\ Installer/English/UninstallSentinelKeysProtection.sh

echo "This script will uninstall the following components:"
echo
echo "      1. Sentinel System Driver"
echo "      2. Sentinel Keys Server"
echo

### Check if Sentinel SDK Package installed
  #[ -d "/Library/Receipts/SentinelKeysSDK.pkg" ]
    sudo chmod 777 /Library/Receipts/SafenetSentinelProduct.Info
   `grep SentinelKeysSDK /Library/Receipts/SafenetSentinelProduct.Info | cut -d = -f 1` > /dev/null 2>&1
    if [ $? -ne 0 ]
    then
       echo "Cannot uninstall the Sentinel System Driver as well Sentinel Keys Server because some other Package is using them.";echo
       ISDRIVER=1
       ISSERVER=1
    else
      ### Remove the components installed by the Sentinel Keys Protection Installer
       sudo rm -rf "$SKPI_INST_PATH"            
   fi


 ##SDK Package is present but it is old version of package
       [ -f "/Library/Receipts/SafenetSentinelProduct.Info" ]
       if [ $? -eq 0 ]
       then 
          sudo chmod 777 /Library/Receipts/SafenetSentinelProduct.Info
          sdk_version=`grep SentinelKeysSDK /Library/Receipts/SafenetSentinelProduct.Info | cut -d = -f 2 | cut -d : -f 1 | cut -d . -f 1`
          if [ $sdk_version ]
          then
            if [ $sdk_version -lt $CURR_SDK_VERSION ]
            then
              current_inst=`grep SentinelKeysSDK /Library/Receipts/SafenetSentinelProduct.Info | cut -d = -f 3`
              if [ $current_inst = 0 ]
              then  
                  ##Count is 0, old sdk has been removed
                  ISSDK_102=1 
              else 
                  ##Count is greater than 0, old sdk is still present
                  ISSDK_102=2
              fi
           fi
          sudo chmod 775 /Library/Receipts/SafenetSentinelProduct.Info
        fi
      fi

      if [ $ISSDK_102 = 2 ]
      then
         sudo rm -rf "$SKPI_INST_PATH" 
      fi


if [ $ISSERVER = 0 ]
then  
### Stop the Sentinel Keys Server
    sudo sh /Applications/Safenet\ Sentinel/Common\ Files/Sentinel\ Keys\ Server/loadserv.sh stop

### Remove Sentinel Keys Server
    sudo rm -rf "$SRVR_INST_PATH"

### Remove the entry from rc script to start Server 
    sudo echo "/SentinelKeysServer/" > /tmp/SNTLCMD
    sudo echo "d" >> /tmp/SNTLCMD; echo "w" >> /tmp/SNTLCMD; echo "q" >> /tmp/SNTLCMD
 
    (sudo grep "SentinelKeysServer" /etc/rc && sudo ed /etc/rc < /tmp/SNTLCMD) > /dev/null 2>&1

    sudo echo "/Keys/" > /tmp/SNTLCMD
    sudo echo "d" >> /tmp/SNTLCMD; echo "w" >> /tmp/SNTLCMD; echo "q" >> /tmp/SNTLCMD
    (sudo grep "Keys" /etc/rc && sudo ed /etc/rc < /tmp/SNTLCMD) > /dev/null 2>&1

    sudo echo "/loadserv/" > /tmp/SNTLCMD
    sudo echo "d" >> /tmp/SNTLCMD; echo "w" >> /tmp/SNTLCMD; echo "q" >> /tmp/SNTLCMD
    (sudo grep "loadserv" /etc/rc && sudo ed /etc/rc < /tmp/SNTLCMD) > /dev/null 2>&1

    sudo ed /etc/rc < /tmp/SNTLCMD > /dev/null 2>&1
    sudo echo "d" >> /tmp/SNTLCMD; echo "w" >> /tmp/SNTLCMD; echo "q" >> /tmp/SNTLCMD
    rm /tmp/SNTLCMD

fi

### Check if /Applications/Safenet\ Sentinel/Common\ Files is empty
       val=`ls /Applications/Safenet\ Sentinel/Common\ Files` 
       if [ "$val" = "" ]
       then
          sudo rm -rf /Applications/Safenet\ Sentinel/Common\ Files
       fi

### Check if /Applications/Safenet\ Sentinel/Sentinel\ Keys/1.3 is empty
    sudo rm -rf /Applications/Safenet\ Sentinel/Sentinel\ Keys/1.3/.DS_store > /dev/null 2>&1
    val=`ls /Applications/Safenet\ Sentinel/Sentinel\ Keys/1.3`
    if [ "$val" = "" ]
    then
      sudo rm -rf /Applications/Safenet\ Sentinel/Sentinel\ Keys/1.3
    fi

### Check if $ISSDK_102=1, old version of SDK had been installed.
    if [ $ISSDK_102 = 1 ]
    then
      sudo rm -rf /Applications/Safenet\ Sentinel/Sentinel\ Keys/1.0
    fi


### Check if /Applications/Safenet\ Sentinel/Sentinel\ Keys is empty
    sudo rm -rf /Applications/Safenet\ Sentinel/Sentinel\ Keys/.DS_store > /dev/null 2>&1 
    val=`ls /Applications/Safenet\ Sentinel/Sentinel\ Keys`
    if [ "$val" = "" ]
    then
       sudo rm -rf /Applications/Safenet\ Sentinel/Sentinel\ Keys
    fi

## Check if /Applications/Safenet\ Sentinel is empty
   sudo rm -rf /Applications/Safenet\ Sentinel/.DS_store > /dev/null 2>&1 
   val=`ls /Applications/Safenet\ Sentinel`
   if [ "$val" = "" ]
   then
     sudo rm -rf /Applications/Safenet\ Sentinel
   fi
   
### Check if Sentinel Keys License Manager Package installed
if [ $ISDRIVER = 0 ]
then
    [ -d "/Library/Receipts/SentinelKeysLicenseManager.pkg" ]
    if [ $? -eq 0 ]
    then
      echo "Cannot uninstall the Sentinel System Driver because some other Package is using it.";echo      
      ISDRIVER=1
    fi
fi

### Check whether Ultrapro SDK package is installed
if [ $ISDRIVER = 0 ]
then    
   [ -d "$UPRO_PCKG_PATH" ]
    if [ $? -eq 0 ]
    then
      echo "Cannot uninstall the Sentinel System Driver because some other Package is using it.";echo
      ISDRIVER=1
    fi
fi

### Check whether Ultrapro SPI package is installed
if [ $ISDRIVER = 0 ]
then  
# [ -d "$UPRO_SPI_PATH" ]
  [ -d /Applications/Sentinel/Sentinel\ Protection\ Server ]
    if [ $? -eq 0 ]
    then
      echo "Cannot uninstall the Sentinel System Driver because some other Package is using it.";echo
      ISDRIVER=1
    fi
fi

### Check whether Ultrapro Framework package is installed
if [ $ISDRIVER = 0 ]
then
    [ -d "$UPRO_FRMWRK_PATH" ]
    if [ $? -eq 0 ]
    then
      echo "Cannot uninstall the Sentinel System Driver because some other Package is using it.";echo
      ISDRIVER=1
    fi
fi

### Check whether Ultrapro KM package is installed
if [ $ISDRIVER = 0 ]
then  
    [ -d "$UPRO_KM_PATH" ]
    if [ $? -eq 0 ]
    then
      echo "Cannot uninstall the Sentinel System Driver because some other Package is using it.";echo
      ISDRIVER=1
    fi
fi

### Check if Sentinel System Driver Package installed
if [ $ISDRIVER = 0 ]
then
  # [ -d "/Library/Receipts/SentinelSystemDriver.pkg" ]
    sudo chmod 777 /Library/Receipts/SafenetSentinelProduct.Info
    `grep SentinelSystemDriver /Library/Receipts/SafenetSentinelProduct.Info | cut -d = -f 1` > /dev/null 2>&1
    if [ $? -ne 0 ]
    then 
      echo "Cannot uninstall the Sentinel System Driver because some other Package is using it.";echo      
      ISDRIVER=1
    fi
fi

### Checking if SuperPro is installed.
if [ $ISDRIVER = 0 ]
then
   [ -d $SUPRO_PCKG_PATH ]
   if [ $? -eq 0 ]
   then
     echo "Cannot uninstall the Sentinel System Driver because some other Package is using it.";echo
     ISDRIVER=1
   fi
fi

### Checking whether SuperPro Driver is installed
if [ $ISDRIVER = 0 ]
then  
 [ -d $SUPRO_DRIVER_PATH ]
   if [ $? -eq 0 ]
   then
     echo "Cannot uninstall the Sentinel System Driver because some other Package is using it.";echo
     ISDRIVER=1
   fi
fi

if [ $ISDRIVER = 0 ]
then
# Unload the Sentinel System Driver
sudo kextstat | grep Sentinel > /dev/null 2>&1
if [ $? = 0 ]; then
  echo "Unload the Sentinel System Driver..."; echo
  touch /tmp/temp > /dev/null 2>&1
  ( sudo kextunload /System/Library/Extensions/Sentinel.kext | tee /tmp/temp > /dev/null 2>&1 )
  if [ `wc -c < /tmp/temp` = 0 ]; then
       echo "Sentinel System Driver unloaded successfully."; echo 
    else
      grep Failed /tmp/temp > /dev/null 2>&1
  if [ $? = 0 ]; then
     echo "Failed to unload the driver.";echo
     rm /tmp/temp
   else 
     echo "Sentinel System Driver unloaded successfully."; echo
  fi
 fi
    rm -rf /tmp/temp
 fi
 
### Remove Sentinel.kext 
    echo "Remove the Sentinel.kext"; echo
    [ -d /System/Library/Extensions/Sentinel.kext ]
    if [ $? -eq 0 ]
    then
       sudo rm -rf /System/Library/Extensions/Sentinel.kext
    fi

### Remove Framework
    sudo rm -rf "$FRMWRK_INST_PATH"
fi

### Remove the package entry from /Library/Receipts/
    sudo rm -rf "$PCKG_INST_PATH"
    if [ $? -ne 0 ]
    then
        echo "Error occured while uninstalling Sentinel Keys Protection Installer package.";echo
        exit
    fi        

echo "Sentinel Keys Protection Installer version 1.3.1 uninstalled successfully.";echo

